unit umain;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ComCtrls,

  fphttpclient, OpenSSLSockets, OpenSSL,

  {$ifdef windows}fileinfo,{$endif} winpeimagereader, elfreader, machoreader
  
  {$ifdef linux}, Process{$endif}
  ;  

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Edit1: TEdit;
    Memo1: TMemo;
    StatusBar1: TStatusBar;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    function GetSSLVersion: string;
  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
var
  http: TFPHTTPCLIENT;
  Response: TMemoryStream;
begin
  Memo1.Clear;
  InitSSLInterface; // <- !
  http := TFPHTTPCLIENT.Create(nil);
  Response := TMemoryStream.Create;
  try
    try
      http.Get(Edit1.Text, Response);
      Response.Seek(0, soFromBeginning);
      Memo1.Lines.LoadFromStream(Response);

      StatusBar1.Panels[0].Text := http.ResponseStatusText;  // ResponseStatusText
      StatusBar1.Panels[1].Text := http.ResponseStatusCode.ToString;  // ResponseStatusCode
    except
      Memo1.Lines.LoadFromStream(Response);

      StatusBar1.Panels[0].Text := http.ResponseStatusText;  // ResponseStatusText
      StatusBar1.Panels[1].Text := http.ResponseStatusCode.ToString;  // ResponseStatusCode
    end;
  finally
    http.Free;
    Response.Free;
  end;

  // dll version
  StatusBar1.Panels[2].Text := GetSSLVersion;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Memo1.Clear;
end;

function TForm1.GetSSLVersion: string;
var
  {$ifdef windows}
    FileVerInfo: TFileVersionInfo;
  {$endif}
  {$ifdef linux}
    AProcess: TProcess;
    AStringList: TStringList;
    AStringArray: TStringArray;
  {$endif}
begin
  Result := '';
  {$ifdef windows}
  FileVerInfo := TFileVersionInfo.Create(nil);
  try
    FileVerInfo.FileName := 'ssleay32.dll';
    FileVerInfo.ReadFileInfo;
    Result := FileVerInfo.VersionStrings.Values['ProductVersion'];
  finally
    FileVerInfo.Free;
  end;
  {$endif}

  {$ifdef linux}
    AProcess := TProcess.Create(nil);
    AStringList := TStringList.Create;
    try
      AProcess.Executable := 'openssl';
      AProcess.Parameters.Add('version');
      AProcess.Options := AProcess.Options + [poWaitOnExit, poUsePipes];
      AProcess.Execute;
      AStringList.LoadFromStream(AProcess.Output);
      AStringArray := AStringList.CommaText.Split(' ');
      Result := Trim(AStringArray[1]);
    finally
      AProcess.Free;
      AStringList.Free;
    end;
  {$endif}
end;

end.

